> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/vnic/assignnetworkinterfaceipv4.md).

# AssignNetworkInterfaceIpv4

## 1. API Description

This API (AssignNetworkInterfaceIpv4) is used to assign a private IPv4 address to a network interface.

{% hint style="info" %}
**Notes**

* The network interface status must be `AVAILABLE` or `USED`.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                                                                       |
| -------------- | -------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| nicId          | Yes      | String | <p>ID of the network interface to be bound.</p><p>It can be obtained by calling <a href="/api-reference/zec/vnic/describenetworkinterfaces.md">DescribeNetworkInterfaces</a>.</p> |
| ipAddress      | Yes      | String | <p>Private IPv4 address to be bound.</p><p>The address must fall within the subnet's CIDR range and must not already be in use.</p>                                               |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Assign the private IPv4 to the vNIC.**

<pre class="language-json"><code class="lang-json"><strong>POST /api/v2/zec HTTP/1.1
</strong>Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: AssignNetworkInterfaceIpv4


Request:
{
  "nicId": "XXX",
  "ipAddress": "xxx"
}

Response:
{
  "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
  "response": {
    "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F"
  }
}
</code></pre>

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                          | Description                                               |
| ---------------- | --------------------------------------------------- | --------------------------------------------------------- |
| 400              | INVALID\_IP\_BROADCAST\_ADDRESS                     | The IP address cannot be a broadcast address.             |
| 400              | INVALID\_IP\_FIRST\_ADDRESS                         | The IP address cannot be a gateway address.               |
| 400              | INVALID\_IP\_NETWORK\_ADDRESS                       | The IP address cannot be a network address.               |
| 404              | INVALID\_NIC\_NOT\_FOUND                            | vNIC does not exist.                                      |
| 400              | INVALID\_NIC\_STATUS                                | Current vNIC state does not allow this operation.         |
| 400              | OPERATION\_DENIED\_SUBNET\_TYPE\_NOT\_SUPPORT\_IPV4 | Subnet type does not support IPv4.                        |
| 400              | INVALID\_IP\_OUT\_OF\_RANGE                         | Invalid IP address. It does not belong to the CIDR block. |
| 409              | INVALID\_SUBNET\_PRIVATE\_IPV4\_IN\_USED            | Private IPv4 is occupied.                                 |
